<template lang="html">
  <div class="">
    <hero>{{ heroTitle.INSPECT_TITLE }}</hero>

    <section class="section">
      <div class="container box">

        <div class="level">
          <div class="level-left">
          </div>
          <div class="level-right">
            <div class="level-item">
              <button class="button" @click="showConfigToggle">Config</button>
            </div>
          </div>
        </div>

        <processing-config v-show="showConfig" />

        <div class="columns is-multiline" v-if="!emptyImages">
          <div class="column is-half" v-for="image in images._items" v-bind:key="image._id">
            <div class="card">
              <div class="card-header-title level">
                <div class="level-left">
                  <div class="level-item">
                    {{ image.filename }}
                  </div>
                </div>
                <div class="level-right">
                  <div class="level-item">
                    <button class="delete" aria-label="delete" @click.stop="selectData(image)"></button>
                  </div>
                </div>
              </div>
              <div class="card-image">
                <figure class="image is-4by3">
                  <img :src="'data:image/jpg;base64, '+image.raw_file.file" :alt="image.filename">
                </figure>
                <footer class="card-footer">
                  <a class="card-footer-item" @click.stop="stepsProcess(image._id)">Step-by-step Image Processing</a>
                  <a class="card-footer-item" @click.stop="histogramProcess(image._id)">Histogram</a>
                </footer>
              </div>
            </div>
          </div>
        </div>

        <div v-else>
          <file-select/>
        </div>

        <div class="" v-if="modalActive">
          <step-modal v-if="!isHistModal"
            :images="step_processed"
            :is-processed="isProcessed"
            v-on:close-modal="modalActiveToggle"/>

          <histogram-modal v-else
            :hists="getHistogram()"
            :is-processed="isProcessed"
            :image="processed_img"
            v-on:close-modal="modalActiveToggle"/>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import Hero from '@/components/base/Hero'
import FileSelect from '@/components/base/FileSelect'
import StepModal from '@/components/base/StepModal'
import ProcessingConfig from '@/components/base/ProcessingConfig'
import HistogramModal from '@/components/base/HistogramModal'

export default {
  components: { Hero, FileSelect, StepModal, ProcessingConfig, HistogramModal },
  data() {
    return {
    // not included into global state because why it should?
      modalActive : false,
      isProcessed: false,
      showConfig: false,
      isHistModal: false,
      selectedImage: undefined
    }
  },
  computed: {
    heroTitle() {
      return this.$store.getters.getHeroTitle
    },
    images() {
      return this.$store.state.images
    },
    emptyImages() {
      return this.$store.state.images._items.length === 0
    },
    step_processed() {
      return this.$store.state.step_processed._items
    },
    processed_img() {
      return this.$store.state.temp.detected
    }
    // histogram() {
    //   return this.$store.state.histogram._items
    // }
  },
  methods: {
    selectData(selectedData) {
      this.$store.commit('setTemp', {temp: selectedData})
      this.$store.commit('setDialogState', {dialogState: true})
    },
    getHistogram() {
      return this.$store.getters.getHistogram(this.selectedImage)
    },
    modalActiveToggle() {
      this.isProcessed = false
      this.modalActive = !this.modalActive
      return this.modalActive
    },
    showConfigToggle() {
      this.showConfig = !this.showConfig
    },
    updateisStepped(imageId) {
      return this.$store.commit('updateClientIsStepped', {
        id: imageId,
        value: true
      })
    },
    histogramProcess(imageId) {
      var command = ""
      this.selectedImage = imageId
      this.isHistModal = true
      this.modalActiveToggle()
      if (this.$store.getters.isHistogramExist(imageId)) {
        command = 'put_histogram'
      } else {
        command = 'post_histogram'
      }
      this.$store.dispatch('computeHistogram',
        [{command: command, scope: ['single'], ref_id: imageId}]
      ).then(() => this.$store.dispatch('loadImageToTemp', {
        filter: {
          projection: {detected: 1},
        },
        id: imageId
      }).then(() => this.isProcessed = true))
    },
    stepsProcess(imageId) {
      this.isHistModal = false
      this.modalActiveToggle()
      if (this.$store.getters.isStepped(imageId)) {
        // fetch stepped images
        // this.$store.dispatch('loadStepped', {where: {ref_id: imageId}})
        this.$store.dispatch('stepProcessImages', {
          command: 'put_steps',
          scope: ['single'],
          ref_id: imageId
        }).then(()=> this.isProcessed = true)

      } else {
        // send a command for stepping an image and fetch it
        this.$store.dispatch('stepProcessImages', {
          command: 'post_steps',
          scope: ['single'],
          ref_id: imageId
        }).then((response) => this.$store.dispatch('loadImages', {projection: {raw_file: 1, filename: 1, is_stepped: 1}}))
          .then(() => this.isProcessed = true)
      }
    }
  },
  beforeMount() {
    this.modalActive = false
    this.isProcessed = false
    this.$store.dispatch('loadImages', {projection: {raw_file: 1, filename: 1, is_stepped: 1}})
    this.$store.dispatch('loadHistogram', {projection: {hist:1, ref_id: 1, groups: 1}})
  }
}
</script>

<style lang="scss" scoped>
</style>
